package fr.inra.pappso.FastaManager.FastaFile;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;



public class FastaFileFactory {

	public static FastaFile newFastaFile(String filename) {
		try {
			URL fastaUrl = new URL(filename);
			
			return FastaFileFactory.newFastaFile(fastaUrl);
		} catch (MalformedURLException e) {
			// this is not an URL
			return newFastaFile(new File(filename)); 
		}
	}

	public static FastaFile newFastaFile(URL fastaUrl) {
		return new FastaWebdavFile(fastaUrl);
	}

	public static FastaFile newFastaFile(File file) {
		FastaFile returnFile = new FastaLocalFile(file);
		return returnFile;
	}

}
