package fr.inra.pappso.FastaManager.database;

import org.apache.log4j.Logger;
import org.w3c.dom.*;

import com.googlecode.sardine.Sardine;
import com.googlecode.sardine.SardineFactory;

import fr.inra.pappso.FastaManager.FastaFile.FastaFile;
import fr.inra.pappso.FastaManager.FastaFile.FastaWebdavFile;
import fr.inra.pappso.FastaManager.exception.FastaException;
import fr.inra.pappso.FastaManager.fasta_transforme.output.FastaOutputSardine;
import fr.inra.pappso.FastaManager.fasta_transforme.output.FastaWriter;

import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;

public class RepositoryWebdav extends Repository {
	private static final Logger logger = Logger
			.getLogger(RepositoryWebdav.class);

	public RepositoryWebdav(Element repositorie) throws Exception {
		super(repositorie);
	}

	@Override
	protected InputStream getXmlInputStream() throws Exception {
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));
		logger.debug("get " + file);
		return (sardine.get(file));
	}

	@Override
	protected void writeToFile(InputStream is) throws Exception {
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));
		sardine.put(file, is);
	}

	@Override
	protected boolean isXmlExist() throws Exception {
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));
		return (sardine.exists(file));
	}

	@Override
	public FastaWriter newFastaWriter() throws IOException, FastaException {
		String filename = get_database_repository()
				+ System.getProperty("file.separator") + this.select_new_id()
				+ ".fasta";
		logger.debug(filename);
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));

		return new FastaOutputSardine(sardine, new URL(filename));
	}

	@Override
	public FastaFile getFastaFile(Element element) {

		String species = element.getAttribute("fasta_file");
		// FastaFile fastaFile = FastaFileFactory.newFastaFile(this
		// .get_database_repository() + "/" + species);
		URL fastaUrl = null;
		try {
			fastaUrl = new URL(this.get_database_repository() + "/" + species);
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			logger.error(e.getMessage());
		}
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));

		FastaWebdavFile fastaFile = null;

		fastaFile = new FastaWebdavFile(sardine, fastaUrl);

		// Element database = (Element) o;
		return (fastaFile);
	}

	public void unlock() throws Exception {
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));
		String locking = this.file + ".lock";
		if (!this.readOnly && sardine.exists(locking)) {
			sardine.delete(locking);
		}

	}

	public void lock() throws Exception {
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));
		byte[] b = new byte[100];
		sardine.put(this.file + ".lock", b);
	}

	public boolean islock() throws Exception {
		Sardine sardine = SardineFactory.begin(
				repositorie.getAttribute("login"),
				repositorie.getAttribute("password"));
		return (sardine.exists(file + ".lock"));
	}

}
