package fr.inra.pappso.FastaManager.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;

import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame;
import javax.swing.SpringLayout;

import org.w3c.dom.Element;

import fr.inra.pappso.FastaManager.database.Repository;

public class edit_window extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;

	private Repository xml;

	private Hashtable<String,Element> ids;

	private String id;

	private JLabel id_label = new JLabel();

	private JLabel combine = new JLabel();

	private JTextField source = new JTextField();

	private JTextField species = new JTextField();

	private JTextField version = new JTextField();

	private JLabel entries = new JLabel();

	private JLabel type = new JLabel();

	private JTextField fasta_file = new JTextField();

	private JTextField site_web = new JTextField();

	private JTextArea description = new JTextArea();

	public edit_window(JFrame owner, boolean modal, Repository x, String i) {
		super(owner, modal);
		this.xml = x;
		this.id = i;
		// initialise la fenetre
		init();
		// ajoute les données
		add_data();

		// regle et affiche la fenetre
		setSize(400, 400);
		setLocationRelativeTo(owner);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setVisible(true);
	}

	private void init() {
		// creation de la boite de Dialogue
		this.setTitle("Editing of the database metadatas");
		this.setLayout(new BorderLayout());
		JPanel pane1 = new JPanel();
		JPanel pane2 = new JPanel();
		JPanel pane3 = new JPanel();

		// pane1.setLayout(new GridLayout(9, 2));
		pane1.setLayout(new SpringLayout());
		JLabel l = new JLabel("Combination of : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(combine);
		pane1.add(combine);
		l = new JLabel("Id : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(id_label);
		pane1.add(id_label);
		l = new JLabel("Source : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(source);
		pane1.add(source);
		l = new JLabel("Species :", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(species);
		pane1.add(species);
		l = new JLabel("Version : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(version);
		pane1.add(version);
		l = new JLabel("Entries : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(entries);
		pane1.add(entries);
		l = new JLabel("Type : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(type);
		pane1.add(type);
		l = new JLabel("Web site : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(site_web);
		pane1.add(site_web);
		l = new JLabel("File : ", JLabel.TRAILING);
		pane1.add(l);
		l.setLabelFor(fasta_file);
		pane1.add(fasta_file);
		SpringUtilities.makeCompactGrid(pane1, 9, 2, // rows, cols
				0, 0, // initX, initY
				2, 2);
		this.add(pane1, BorderLayout.NORTH);

		pane2.setLayout(new BorderLayout());
		pane2.add(new JLabel("Description"), BorderLayout.NORTH);
		pane2.add(new JScrollPane(description), BorderLayout.CENTER);
		this.add(pane2, BorderLayout.CENTER);

		JButton ok = new JButton("ok");
		JButton cancel = new JButton("cancel");
		ok.addActionListener(this);
		cancel.addActionListener(this);
		pane3.add(ok);
		pane3.add(cancel);
		this.add(pane3, BorderLayout.SOUTH);

	}

	private void add_data() {
		ids = xml.get_databases();
		combine.setText(xml.get_combinaison(ids.get(id)));
		id_label.setText(xml.get_id(ids.get(id)));
		source.setText(xml.get_source_database(ids.get(id)));
		species.setText(xml.get_species(ids.get(id)));
		version.setText(xml.get_version(ids.get(id)));
		entries.setText(xml.get_entries(ids.get(id)));
		type.setText(xml.get_type(ids.get(id)));
		site_web.setText(xml.get_site_web(ids.get(id)));
		fasta_file.setText(xml.getFastaFile(ids.get(id)).getName());
		description.setText(xml.get_description(ids.get(id)));
	}

	private void ok_clic() {
		xml.set_source_database(ids.get(id), source.getText());
		xml.set_species(ids.get(id), species.getText());
		xml.set_version(ids.get(id), version.getText());
		xml.set_site_web(ids.get(id), site_web.getText());

		xml.set_description(ids.get(id), description.getText());
		try {
			if(!xml.getFastaFile(ids.get(id)).getName().equals(fasta_file.getText()))
				xml.renameFastaFile(ids.get(id), fasta_file.getText());
			xml.write();
			JOptionPane.showMessageDialog(this,
					"Saved of the modification finish", "Message",
					JOptionPane.INFORMATION_MESSAGE);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this,
					"Problems during modification saving :\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE);
		} finally {
			dispose();
		}
	}

	public void actionPerformed(ActionEvent evt) {
		String composant = evt.getActionCommand();
		if (composant.equalsIgnoreCase("ok"))
			ok_clic();
		if (composant.equalsIgnoreCase("cancel"))
			dispose();
	}
}
