package fr.inra.pappso.FastaManager.sequence_transforme;

import fr.inra.pappso.FastaManager.exception.FastaException;
import fr.inra.pappso.FastaManager.sequence.sequence;


public class seq_est_translate_in_one_frame extends seq_transforme {
	private int frame;
	private table_codon table;

	public seq_est_translate_in_one_frame() {
		this.seq_out = new sequence[1];
		this.frame = 1;
		this.table = new table_codon();
	}

	public void set_frame(int f) throws FastaException {
		if ((f < -3))
			throw new FastaException("The frame " + f
					+ " is not valid. Frame valide -1, -2, -3, 1, 2, 3");
		if ((f == 0))
			throw new FastaException("The frame " + f
					+ " is not valid. Frame valide -1, -2, -3, 1, 2, 3");
		if ((f > 3))
			throw new FastaException("The frame " + f
					+ "  is not valid. Frame valide -1, -2, -3, 1, 2, 3");
		this.frame = f;
	}

	public int get_frame() {
		return (this.frame);
	}

	public sequence[] transforme(sequence S) throws Exception {
		int orf = 0;// cadre de lecture
		String codon = null;// codon
		String seq_prot = "";// sequence traduite
		seq_transforme mode;// methode de transformation

		if (this.frame > 0) {
			orf = this.frame;
			mode = new seq_to_seq_est();
		} else {
			orf = -this.frame;
			mode = new seq_est_to_reverse_complement();
		}
		this.seq_out = mode.transforme(S);// transformation

		for (int i = orf - 1; i < this.seq_out[0].get_sequence().length(); i += 3) {
			if (i + 3 <= this.seq_out[0].get_sequence().length()) {
				codon = this.seq_out[0].get_sequence().substring(i, i + 3);
				try {
					seq_prot += this.table.get_aa_to_codon(codon);
				} catch (Exception e) {
					throw (e);
				}
			}
		}
		mode = new seq_to_seq_protein();
		this.seq_out = mode.transforme(this.seq_out[0]);// transformation
		this.seq_out[0].set_accession(this.seq_out[0].get_accession()
				+ "|Frame" + this.frame);
		this.seq_out[0].set_sequence(seq_prot);
		return (this.seq_out);
	}
	public String get_sequence_type(){
		return("EST translated in Frame "+this.frame);
	}
	public String get_type(){
		return("PROT");
	}

}
