package fr.inra.pappso.FastaManager.fasta_transforme.output;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.net.URL;

import org.apache.log4j.Logger;

import com.googlecode.sardine.Sardine;

class OutputSardineThread extends Thread {
	private static final Logger logger = Logger
			.getLogger(OutputSardineThread.class);
	PipedOutputStream pos = null;
	PipedInputStream pis = null;
	private Sardine sardine;

	private URL urlOutput;

	OutputSardineThread(Sardine sardine, URL urlOutput) throws IOException {
		this.sardine = sardine;
		this.urlOutput = urlOutput;
		pos = new PipedOutputStream();
		pis = new PipedInputStream(pos);
	}

	synchronized public void close() {
		try {
			if (pos != null) {
				pos.flush();
				pos.close();
				pos = null;
			}
			if (pis != null) {
				pis.close();
				pis = null;
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	synchronized public OutputStream getOutputStream() {
		return pos;
	}

	public void run() {
		logger.debug("run ");
		try {
			sardine.put(urlOutput.toString(), pis);
		} catch (IOException e) {
			logger.error("IOException " + e.getMessage());
		}

	}

}
