package fr.inra.pappso.FastaManager.sequence_transforme;

import fr.inra.pappso.FastaManager.sequence.sequence;
import fr.inra.pappso.FastaManager.sequence.sequence_prot;

public class seq_protein_translate_to_select_orf extends seq_transforme {

	private String[] orfs;
	private seq_transforme mode;
	
	public seq_protein_translate_to_select_orf() {
		this.seq_out = new sequence_prot[1];
		this.orfs = null;
		this.mode = new seq_to_seq_protein();
	}

	public sequence[] transforme(sequence seq) throws Exception {
		try {
			this.orfs = seq.get_sequence().split("-");
			if (this.orfs.length == 1){
				this.seq_out = this.mode.transforme(seq);
				return (this.seq_out);
			}
			String sequence = this.orfs[0];
			for (int i=1; i<this.orfs.length; i++){
				if (this.orfs[i].length()>sequence.length())
					sequence = this.orfs[i];			
			}
			this.seq_out = this.mode.transforme(seq);
			this.seq_out[0].set_accession(this.seq_out[0].get_accession()+"|Orf");
			this.seq_out[0].set_sequence(sequence);
			
		} catch (Exception e) {
			throw (e);
		}
		return (this.seq_out);
	}
	public String get_type(){
		return("EST translated with orf");
	}
	public String get_sequence_type(){
		return("PROT");
	}

}
